package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.MedicaoEfetivosPage;

public class MedicaoEfetivosFlows {

    MedicaoEfetivosPage medicaoEfetivos = new MedicaoEfetivosPage();

    public void acessaMedicao(String unidade, String data){
        medicaoEfetivos.filtroEfetivos(unidade, data);

    }

    public void informaEfetivosPla(String QTDCLIENTE, String QTDFUNCIONARIO, String QTDDOACAO){
        medicaoEfetivos.informaQtdEfetivos(QTDCLIENTE,QTDFUNCIONARIO,QTDDOACAO);
    }

    public void informaEfetivosFatu(String QTDEFETIVOFATU, String QTDVENDAVISTA, String QTDATUAL){
        medicaoEfetivos.efetivosFaturamento(QTDEFETIVOFATU,QTDVENDAVISTA, QTDATUAL);
    }

    public void filtrarUnidade(String CDUNIDADE){medicaoEfetivos.filtrarUnidade(CDUNIDADE);}

    public void selecionaRelatorio(String nomeRelatorio){
        medicaoEfetivos.emiteReltorio(nomeRelatorio);
    }

    public void definirPeriodoRelatorio(String dtInicial, String dtFinal){ medicaoEfetivos.definirPeriodo(dtInicial,dtFinal);
    }

    public String retornaEfetivosCliente(){return medicaoEfetivos.efetivosCliente();}

    public String retornaEfetivosFuncionario(){return medicaoEfetivos.efetivosFuncionario();}

    public String retornaEfetivosDoacao(){return medicaoEfetivos.efetivosDoacao();}

    public String retornaTotalEfetivos(){return medicaoEfetivos.efetivosTotal();}

    public String retornaEfetivosFaturamento(){return medicaoEfetivos.efetivosFaturamento();}

    public void zerarQuantidadeEfetivos(){medicaoEfetivos.zerarQtdEfetivos();}

}
