package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.PrevisaoDeConsumoPage;

public class PrevisaoDeConsumoFlows {
    PrevisaoDeConsumoPage previsaoDeConsumoPage = new PrevisaoDeConsumoPage();

    public void acessarTelaPrevisaoDeConsumo(){previsaoDeConsumoPage.navegarPrevisaoDeConsumo();}

    public void selecionarRelatorios(String nomeRelatorio){previsaoDeConsumoPage.selecionarRelatorio(nomeRelatorio);}

    public void selecionarPeriodo(String DTINICIAL, String DTFINAL){previsaoDeConsumoPage.definePeriodo(DTINICIAL,DTFINAL);}

    public void selecionarUnidades(String CDUNIDADE){previsaoDeConsumoPage.selecionaUnidade(CDUNIDADE);}

    public void selecionaServico(String CDSERVFILI){previsaoDeConsumoPage.selecionaServico(CDSERVFILI);}

    public void definirNivelProduto(){previsaoDeConsumoPage.defineNivelProduto();}

    public void emitirRelatorio(String QTDACRESCIMO){previsaoDeConsumoPage.nivelProdutoRelatorio(QTDACRESCIMO);}

    public void validarUrlGeradaFecharAba(String nomeRelatorio){previsaoDeConsumoPage.fecharAbaRelatorio(nomeRelatorio);}

    public void validarCampoObrigatorio(){previsaoDeConsumoPage.validaCampoObrigatorio();}


    public void alteraFiltroRelatorio(){
        previsaoDeConsumoPage.alteraFiltroRelatorio();
    }
}
