package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class AnaliseRestricoesContratuaisPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");

    By telaAnaliseRestricoesContratuais = By.xpath("//span[text() = 'Planejamento » Cardápio » Relatórios']");
    By opcoesTipo = By.xpath("//div[@data-zh-id=\"4189642842848341994\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By campoTipo = By.xpath("//div[@class=\"field-group-rows\"]/div[2]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By tipoContrato = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid open\"]//li[text() = 'Contrato']");
    By tipoPlanejado = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid open\"]//li[text() = 'Planejado']");

    By campoRelatorio = By.xpath("//div[@data-zh-id='4189642811487723761863']//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioGrupoPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Analítico (Mês)']");
    By relatorioGrupoPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Sintético (Mês)']");
    By relatorioGrupoPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Analítico (Semana)']");
    By relatorioGrupoPratoSinteticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Grupo de Pratos Sintético (Semana)']");
    By relatorioLimiteServicoAnalitico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Limite Per Capita por Serviço Analítico']");
    By relatorioLimiteServicoSintetico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Limite Per Capita por Serviço Sintético']");
    By relatorioProdutoGrupoPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Analítico (Mês)']");
    By relatorioProdutoGrupoPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Sintético (Mês)']");
    By relatorioProdutoGrupoPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Analítico (Semana)']");
    By relatorioProdutoGrupoPratoSinteticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Produtos por Grupo de Prato Sintético (Semana)']");
    By relatorioPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Analítico (Mês)']");
    By relatorioPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Sintético (Mês)']");
    By relatorioPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Analítico (Semana)']");
    By relatorioPratoSinteticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Pratos Sintético (Semana)']");
    By relatorioOpcoesGrupoPratoAnaliticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Opções por Grupo de Prato Analítico (Mês)']");
    By relatorioOpcoesGrupoPratoSinteticoMes = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Opções por Grupo de Prato Sintético (Mês)']");
    By relatorioOpcoesGrupoPratoAnaliticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Opções por Grupo de Prato Analítico (Semana)']");
    By relatorioOpcoesGrupoPratoSinteticoSemana = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Frequência de Opções por Grupo de Prato Sintético (Semana)']");
    By relatorioRestricoesGrupoAnalitico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Restrições de Produtos por Grupo de Prato Analítico']");
    By relatorioRestricoesGrupoSintetico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Restrições de Produtos por Grupo de Prato Sintético']");

    By campoAgrupamentoUnidade = By.id("NMGRUPFILI");
    By agrupamentoMateriaPrima = By.xpath("//div[@data-zh-id=\"4189642824053476841867\"]//span[text() = '0000000002 | MATERIA PRIMA - MATERIAL DE EMBALAGEM']");

    By campoAgrupamentoPrato = By.id("NMAGRUPGRPRAT");
    By agrupamentoPratoSolicitados = By.xpath("//div[@data-zh-field-name=\"NMAGRUPGRPRAT\"]//span[text() = 'SOLICITADOS']");

    By campoGrupoPrato = By.id("NMGRUPOPRATO");
    By grupoPratoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeSelecionadaCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@class=\"zh-select-item\"][1]");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO JABAQUARA']");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 129']");

    By campoGrupoServico = By.id("NMGRUPSERV");
    By grupoGeral = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'GERAL']");

    By campoServico = By.id("NMSERVICO");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']//span[text() = 'Ok']");

    By campoProdutoInicial = By.id("NMPRODINI");
    By produtoInicial = By.xpath("//div[@data-zh-id='4189642825413897711894']//span[text() = '0 | REFEIÇÕES TRANSPORTADAS']");
    By botaoPesquisarProdutoFinal = By.xpath("//div[@id='NMPRODFIN']//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurarProdutoFinal = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By campoProdutoFinal = By.id("NMPRODFIN");
    By produtoFinal = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'COLA DE CONTATO']");

    By campoMes = By.id("MES");
    By anoCalendario = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//h3[@class=\"calendar-heading\"]");
    By botaoRetornarAno = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//div[@zh-icon=\"previous no-border\"]");
    By mesNovembro = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Nov']");
    By botaoCampoMes = By.xpath("//div[@id=\"MES\"]//span[@style=\"background-image: none; display: block;\"]");

    By ordenacaoCodigo = By.xpath("//label[@for='radio-IDORDENAGR-C']//div[@class='zh-inner-circle']");
    By ordenacaoAlfabetica = By.xpath("//label[@for='radio-IDORDENAGR-A']//div[@class='zh-inner-circle']");
    By inputRedioButtonOrdCodigo = By.id("radio-IDORDENAGR-C");
    By inputRedioButtonOrdAlfabetica = By.id("radio-IDORDENAGR-A");

    By checkExbibeProdutoDivergentes = By.xpath("//label[@for=\"zh-checkbox-IDPRODDIVERG\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCheckProdutosDivergentes = By.id("zh-checkbox-IDPRODDIVERG");

    By mensagemObrigatorioTipo = By.xpath("//div[@data-zh-id=\"4189642842848341994\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"418964286711471151871\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"4189642815591461781879\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioMes = By.xpath("//div[@data-zh-id=\"418964287940067671893\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioProdutoInicial = By.xpath("//div[@data-zh-id=\"4189642825413897711894\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioProdutoFinal = By.xpath("//div[@data-zh-id=\"4189642837021019851897\"]//span[@class=\"zh-validation-error\"]");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        tempo();
        click(botaoMenu);
        sendKeys(campoPesquisar, "Análise de Restrições Contratuais");
        click(telaAnaliseRestricoesContratuais);
    }

    public void selecionarRelatorio(String nomeDoRelatorio) {
        tempo();
        switch (nomeDoRelatorio) {
            case "Frequência de Grupo de Pratos Analítico (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoAnaliticoMes);
                break;
            case "Frequência de Grupo de Pratos Sintético (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoSinteticoMes);
                break;
            case "Frequência de Grupo de Pratos Analítico (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoAnaliticoSemana);
                break;
            case "Frequência de Grupo de Pratos Sintético (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoPratoSinteticoSemana);
                break;
            case "Limite Per Capita por Serviço Analítico":
                clicarCampoSelecionarValor(campoRelatorio, relatorioLimiteServicoAnalitico);
                break;
            case "Limite Per Capita por Serviço Sintético":
                clicarCampoSelecionarValor(campoRelatorio, relatorioLimiteServicoSintetico);
                break;
            case "Frequência de Produtos por Grupo de Prato Analítico (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoAnaliticoMes);
                break;
            case "Frequência de Produtos por Grupo de Prato Sintético (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoSinteticoMes);
                break;
            case "Frequência de Produtos por Grupo de Prato Analítico (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoAnaliticoSemana);
                break;
            case "Frequência de Produtos por Grupo de Prato Sintético (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoGrupoPratoSinteticoSemana);
                break;
            case "Frequência de Pratos Analítico (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioPratoAnaliticoMes);
                break;
            case "Frequência de Pratos Sintético (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioPratoSinteticoMes);
                break;
            case "Frequência de Pratos Analítico (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioPratoAnaliticoSemana);
                break;
            case "Frequência de Pratos Sintético (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioPratoSinteticoSemana);
                break;
            case "Frequência de Opções por Grupo de Prato Analítico (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioOpcoesGrupoPratoAnaliticoMes);
                break;
            case "Frequência de Opções por Grupo de Prato Sintético (Mês)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioOpcoesGrupoPratoSinteticoMes);
                break;
            case "Frequência de Opções por Grupo de Prato Analítico (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioOpcoesGrupoPratoAnaliticoSemana);
                break;
            case "Frequência de Opções por Grupo de Prato Sintético (Semana)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioOpcoesGrupoPratoSinteticoSemana);
                break;
            case "Restrições de Produtos por Grupo de Prato Analítico":
                clicarCampoSelecionarValor(campoRelatorio, relatorioRestricoesGrupoAnalitico);
                break;
            case "Restrições de Produtos por Grupo de Prato Sintético":
                clicarCampoSelecionarValor(campoRelatorio, relatorioRestricoesGrupoSintetico);
                break;
        }
    }

    public void selecionarTipo(String tipo) {
        verificarOpcoesTipo();
        if (tipo.equals("Contrato")) {
            click(tipoContrato);
        } else if (tipo.equals("Planejado")) {
            click(tipoPlanejado);
        }
    }

    public void selecionarAgrupUnMateriaPrima() {
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAgrupamentoUnidade, agrupamentoMateriaPrima);
    }

    public void selecionarUnidades() {
        tempo();
        click(campoUnidade);
        click(unidadeDepositoBc129);
        click(unidadeDepositoJabaquara);
        click(botaoOk);
    }

    public void selecionarGrupoServico() {
        tempo();
        click(campoGrupoServico);
        click(grupoGeral);
        click(botaoOk);
    }

    public void selecionarServicos() {
        tempo();
        click(campoServico);
        click(servicoJantar);
        click(servicoRetiradas);
        click(botaoOk);
    }

    public void selecionarAgrupamentoPrato() {
        tempo();
        click(campoAgrupamentoPrato);
        click(agrupamentoPratoSolicitados);
        click(botaoOk);
    }

    public void selecionarProdutos() {
        tempo();
        clicarCampoSelecionarValor(campoProdutoInicial, produtoInicial);
        click(botaoPesquisarProdutoFinal);
        sendKeys(campoProcurarProdutoFinal, "707");
        click(produtoFinal);
    }

    public void selecionarGrupoPrato() {
        tempo();
        click(campoGrupoPrato);
        click(grupoPratoJantar);
        click(botaoOk);
    }

    public void geraRelatorio() {
        tempo();
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    public void selecionarMesNovembro2023() {
        click(campoMes);
        int ano = Integer.parseInt(getText(anoCalendario));
        if (ano - 2023 != 0) {
            for (int x = (ano - 2023); x > 0; x--) {
                click(botaoRetornarAno);
            }
        }
        click(mesNovembro);

    }

    public void verificaProdutosDivergentes() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 200)");
        boolean exibeProdDivergentes = returnIfElementIsSelected(inputCheckProdutosDivergentes);
        Assert.assertFalse(exibeProdDivergentes, "Verificação se o check-box de 'Exibe apenas Produtos Divergentes', por padrão vem desmarcado");
        click(checkExbibeProdutoDivergentes);
        exibeProdDivergentes = returnIfElementIsSelected(inputCheckProdutosDivergentes);
        Assert.assertTrue(exibeProdDivergentes, "Verificação se após clicar no check-box de 'Exibe apenas Produtos Divergentes', o mesma fica selecionado");
    }

    public void verificarOrdenacao() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 100)");
        boolean codigo = returnIfElementIsSelected(inputRedioButtonOrdCodigo);
        boolean alfabetica = returnIfElementIsSelected(inputRedioButtonOrdAlfabetica);
        Assert.assertTrue(codigo, "Verificar se a ordenação 'Código' já está selecionada por padrão");
        Assert.assertFalse(alfabetica, "Verificar se a ordenação 'Alfabética' já está selecionada por padrão");

        click(ordenacaoAlfabetica);
        codigo = returnIfElementIsSelected(inputRedioButtonOrdCodigo);
        alfabetica = returnIfElementIsSelected(inputRedioButtonOrdAlfabetica);
        Assert.assertFalse(codigo, "Verificar se após clicar em 'Alfabética', o 'Código' não está mais selecionado");
        Assert.assertTrue(alfabetica, "Verificar se após clicar em 'Alfabética' o mesmo passa a estar selecionado");
    }

    public void camposHabilitados() {
        List<String> relatorios = listaRelatorios();

        for (String rel : relatorios) {
            tempo();
            selecionarRelatorio(rel);
            boolean tipo = returnIfClassDisable(campoTipo);
            boolean agrupamentoUnidades = returnIfClassDisable(campoAgrupamentoUnidade);
            boolean unidade = returnIfClassDisable(campoUnidade);
            boolean grupoDeServico = returnIfClassDisable(campoGrupoServico);
            boolean servico = returnIfClassDisable(campoServico);
            boolean agrupamentoPrato = returnIfClassDisable(campoAgrupamentoPrato);
            boolean grupoDePrato = returnIfClassDisable(campoGrupoPrato);
            boolean mes = returnIfClassDisable(campoMes);
            boolean produtoInicial = returnIfClassDisable(campoProdutoInicial);
            boolean produtoFinal = returnIfClassDisable(campoProdutoFinal);
            javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 200)");
            boolean exibeProdutosDivergentes = returnIfElementIsEnabled(inputCheckProdutosDivergentes);
            boolean ordenacaoCodigo = returnIfElementIsEnabled(inputRedioButtonOrdCodigo);
            boolean ordenacaoAlfabetica = returnIfElementIsEnabled(inputRedioButtonOrdAlfabetica);

            Assert.assertTrue(tipo, "Verificar se o campo 'tipo' está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(agrupamentoUnidades, "Verificar se o campo 'agrupamento de unidade' está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(unidade, "Verificar se o campo 'unidade' está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(grupoDeServico, "Verificar se o campo 'grupo serviço' está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(servico, "Verificar se o campo 'serviço' está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(mes, "Verificar se o campo 'mês' está habilitado com o seguinte relatório selecionado: " + rel);
            javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 200)");
            Assert.assertTrue(ordenacaoCodigo, "Verificar se o redio-button 'código' está habilitado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(ordenacaoAlfabetica, "Verificar se o redio-button 'alfabética' está habilitado com o seguinte relatório selecionado: " + rel);


            switch (rel) {
                case "Frequência de Grupo de Pratos Analítico (Mês)":
                case "Frequência de Grupo de Pratos Sintético (Mês)":
                case "Frequência de Grupo de Pratos Analítico (Semana)":
                case "Frequência de Grupo de Pratos Sintético (Semana)":
                case "Frequência de Opções por Grupo de Prato Analítico (Mês)":
                case "Frequência de Opções por Grupo de Prato Sintético (Mês)":
                case "Frequência de Opções por Grupo de Prato Analítico (Semana)":
                case "Frequência de Opções por Grupo de Prato Sintético (Semana)":
                    //produto inicial, produto final e check-box desabilitados
                    Assert.assertTrue(agrupamentoPrato, "Verificar se o campo 'agrupamento de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(grupoDePrato, "Verificar se o campo 'grupo de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(produtoInicial, "Verificar se o campo 'produto inicial' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(produtoFinal, "Verificar se o campo 'produto final' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(exibeProdutosDivergentes, "Verificar se o check-box 'exibe apenas produtos divergentes' está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                case "Frequência de Pratos Analítico (Mês)":
                case "Frequência de Pratos Sintético (Mês)":
                case "Frequência de Pratos Analítico (Semana)":
                case "Frequência de Pratos Sintético (Semana)":
                    //agrupamento de unidades, grupo de prato, produto inicial, produto final e o check-box desabilitados
                    Assert.assertFalse(agrupamentoPrato, "Verificar se o campo 'agrupamento de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(grupoDePrato, "Verificar se o campo 'grupo de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(produtoInicial, "Verificar se o campo 'produto inicial' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(produtoFinal, "Verificar se o campo 'produto final' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(exibeProdutosDivergentes, "Verificar se o check-box 'exibe apenas produtos divergentes' está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                case "Restrições de Produtos por Grupo de Prato Analítico":
                case "Restrições de Produtos por Grupo de Prato Sintético":
                    //possuem apenas o check-box desabilitado
                    Assert.assertTrue(agrupamentoPrato, "Verificar se o campo 'agrupamento de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(grupoDePrato, "Verificar se o campo 'grupo de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(produtoInicial, "Verificar se o campo 'produto inicial' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(produtoFinal, "Verificar se o campo 'produto final' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertFalse(exibeProdutosDivergentes, "Verificar se o check-box 'exibe apenas produtos divergentes' está habilitado com o seguinte relatório selecionado: " + rel);
                    break;

                default:
                    /* os demais relatórios: Limite Per Capita por Serviço Analítico /  Limite Per Capita por Serviço Sintético  /   Frequência de Produtos por Grupo de Prato Analítico (Mês)
                        Frequência de Produtos por Grupo de Prato Sintético (Mês) /  Frequência de Produtos por Grupo de Prato Analítico (Semana)  /  Frequência de Produtos por Grupo de Prato Sintético (Semana)
                        possuem todos os campos habilitados */
                    Assert.assertTrue(agrupamentoPrato, "Verificar se o campo 'agrupamento de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(grupoDePrato, "Verificar se o campo 'grupo de prato' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(produtoInicial, "Verificar se o campo 'produto inicial' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(produtoFinal, "Verificar se o campo 'produto final' está habilitado com o seguinte relatório selecionado: " + rel);
                    Assert.assertTrue(exibeProdutosDivergentes, "Verificar se o check-box 'exibe apenas produtos divergentes' está habilitado com o seguinte relatório selecionado: " + rel);
                    break;
            }

            refresh();
        }
    }

    public void camposObrigatorios() {
        List<String> relatorios = listaRelatorios();

        for (String rel : relatorios) {
            tempo();
            selecionarRelatorio(rel);
            click(unidadeSelecionadaCampoUnidade);
            tempo();
            click(botaoCampoMes);
            tempo();
            click(botaoRelatorio);

            String mensagemEsperada = "Campo obrigatório";
            String tipo = getText(mensagemObrigatorioTipo);
            String unidade = getText(mensagemObrigatorioUnidade);
            String servico = getText(mensagemObrigatorioServico);
            String mes = getText(mensagemObrigatorioMes);

            switch (rel) {
                case "Limite Per Capita por Serviço Analítico":
                case "Limite Per Capita por Serviço Sintético":
                case "Frequência de Produtos por Grupo de Prato Analítico (Mês)":
                case "Frequência de Produtos por Grupo de Prato Sintético (Mês)":
                case "Frequência de Produtos por Grupo de Prato Analítico (Semana)":
                case "Frequência de Produtos por Grupo de Prato Sintético (Semana)":
                case "Restrições de Produtos por Grupo de Prato Analítico":
                case "Restrições de Produtos por Grupo de Prato Sintético":
                    String produtoInicial = getText(mensagemObrigatorioProdutoInicial);
                    String produtoFinal = getText(mensagemObrigatorioProdutoFinal);
                    Assert.assertEquals(produtoInicial, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'produto inicial' com o seguinte relatório selecionado: " + rel);
                    Assert.assertEquals(produtoFinal, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'produto final' com o seguinte relatório selecionado: " + rel);
                break;
            }

            Assert.assertEquals(tipo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'tipo', com o seguinte relatório selecionado: " + rel);
            Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade', com o seguinte relatório selecionado: " + rel);
            Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'serviço', com o seguinte relatório selecionado: " + rel);
            Assert.assertEquals(mes, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'mês', com o seguinte relatório selecionado: " + rel);
            refresh();
        }
    }

    private void verificarOpcoesTipo() {
        click(campoTipo);
        tempo();
        List<String> listaTipos = new ArrayList<>();
        listaTipos.add("Contrato");
        listaTipos.add("Planejado");

        List<WebElement> result = driver.findElements(opcoesTipo);
        Assert.assertEquals(result.size(), 2, "Verificar se o campo tipo possui apenas 2 opções");
        for (int x = 0; x < result.size(); x++) {
            Assert.assertEquals(result.get(x).getText(), listaTipos.get(x), "Verificar se a opção " + (x+1) + " da lista de tipos está correta");
        }
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    private boolean returnIfClassDisable(By campo) {
        return !driver.findElement(campo).getAttribute("class").contains("zh-disabled");
    }

    private List<String> listaRelatorios() {
        List<String> relatorios = new ArrayList<>();
        relatorios.add("Frequência de Grupo de Pratos Analítico (Mês)");
        relatorios.add("Frequência de Grupo de Pratos Sintético (Mês)");
        relatorios.add("Frequência de Grupo de Pratos Analítico (Semana)");
        relatorios.add("Frequência de Grupo de Pratos Sintético (Semana)");
        relatorios.add("Limite Per Capita por Serviço Analítico");
        relatorios.add("Limite Per Capita por Serviço Sintético");
        relatorios.add("Frequência de Produtos por Grupo de Prato Analítico (Mês)");
        relatorios.add("Frequência de Produtos por Grupo de Prato Sintético (Mês)");
        relatorios.add("Frequência de Produtos por Grupo de Prato Analítico (Semana)");
        relatorios.add("Frequência de Produtos por Grupo de Prato Sintético (Semana)");
        relatorios.add("Frequência de Pratos Analítico (Mês)");
        relatorios.add("Frequência de Pratos Sintético (Mês)");
        relatorios.add("Frequência de Pratos Analítico (Semana)");
        relatorios.add("Frequência de Pratos Sintético (Semana)");
        relatorios.add("Frequência de Opções por Grupo de Prato Analítico (Mês)");
        relatorios.add("Frequência de Opções por Grupo de Prato Sintético (Mês)");
        relatorios.add("Frequência de Opções por Grupo de Prato Analítico (Semana)");
        relatorios.add("Frequência de Opções por Grupo de Prato Sintético (Semana)");
        relatorios.add("Restrições de Produtos por Grupo de Prato Analítico");
        relatorios.add("Restrições de Produtos por Grupo de Prato Sintético");

        return relatorios;
    }


//        Frequência de Grupo de Pratos Analítico (Mês) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Grupo de Pratos Sintético (Mês) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Grupo de Pratos Analítico (Semana) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Grupo de Pratos Sintético (Semana) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Limite Per Capita por Serviço Analítico - todos os campos habilitados
//        Limite Per Capita por Serviço Sintético - todos os campos habilitados
//        Frequência de Produtos por Grupo de Prato Analítico (Mês) - todos os campos habilitados
//        Frequência de Produtos por Grupo de Prato Sintético (Mês) - todos os campos habilitados
//        Frequência de Produtos por Grupo de Prato Analítico (Semana) - todos os campos habilitados
//        Frequência de Produtos por Grupo de Prato Sintético (Semana) - todos os campos habilitados
//        Frequência de Pratos Analítico (Mês) - sem agrupamento de prato, grupode prato, produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Pratos Sintético (Mês) - sem agrupamento de prato, grupode prato, produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Pratos Analítico (Semana) - sem agrupamento de prato, grupode prato, produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Pratos Sintético (Semana) - sem agrupamento de prato, grupode prato, produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Opções por Grupo de Prato Analítico (Mês) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Opções por Grupo de Prato Sintético (Mês) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Opções por Grupo de Prato Analítico (Semana) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Frequência de Opções por Grupo de Prato Sintético (Semana) - sem produto inicial produto final e exibe apenas produtos divergentes
//        Restrições de Produtos por Grupo de Prato Analítico - sem exibe apenas produtos divergentes
//        Restrições de Produtos por Grupo de Prato Sintético - sem exibe apenas produtos divergentes

}
